#include "pulsePin.h"
#define DEBUG false
RGBmatrixPanel matrix(A, B, C, CLK, LAT, OE, false);

const int numHeart = 3;
int heart[numHeart][4] = { {  3,  4, -1, -1 }, 
                           { 17, 14, -1,  1 },
                           { 29,  7,  1, -1 } };
int color[numHeart][3] = { { 7,  0,  0 }, 
                           { 0,  7,  0 },
                           { 0,  0,  7 }  };

void drawHeart( int x, int y, unsigned int color);
 
void setup() {
  if (DEBUG) Serial.begin(9600);
  matrix.begin();
}

void loop() { 
  if (DEBUG)  {
     for (int i = 0; i < numHeart; i++)  {
        for (int j = 0; j < 4; j++)  {
           Serial.print(heart[i][j]);   Serial.print("   ");  
        }
     }
     Serial.println();
  }
  
  matrix.fillScreen(0);
  for (int i = 0; i < numHeart; i++)  {
     drawHeart(heart[i][0], heart[i][1], matrix.Color333(color[i][0], color[i][1], color[i][2]));
    
     heart[i][0] += heart[i][2];
     heart[i][1] += heart[i][3];
     
     if ( (heart[i][0] <= 0) || (heart[i][0] >= matrix.width() - 1) )  heart[i][2] *= -1;   
     if ( (heart[i][1] <= 0) || (heart[i][1] >= matrix.height() - 1) )  heart[i][3] *= -1;
  }  
  delay( map(analogRead(SlideL), 0, 1023, 500, 0) );
}

void drawHeart( int x, int y, unsigned int color)  {
  const int sizeD = 7;
  boolean drawInform[sizeD][sizeD] = { {0,1,1,0,1,1,0},
                                       {1,1,1,1,1,1,1},
                                       {1,1,1,1,1,1,1},
                                       {1,1,1,1,1,1,1},
                                       {0,1,1,1,1,1,0},
                                       {0,0,1,1,1,0,0},
                                       {0,0,0,1,0,0,0} };                                    
  int sX = x - (sizeD/2);
  int sY = y - (sizeD/2);                  
  for ( int i = 0; i < sizeD; i++)  {
     for ( int j = 0; j < sizeD; j++) {
        if ( drawInform[i][j]) matrix.drawPixel( sX + j, sY + i, color);     
     }
  }
}

