#include "pulsePin.h"
#define DEBUG false
RGBmatrixPanel matrix(A, B, C, CLK, LAT, OE, false);

const int numBall = 3;
int ball[numBall][4]= { {  3,  4,  -1,  -1 }, 
                        { 17, 14,  -1, 1 },
                        { 29,  7,  1,  -1 } };
int color[numBall][3]= { { 7,  7,  0 }, { 0,  7,  7 }, { 7,  0,  7 }  };                        
int radius = 4;  

boolean stopPlay = false;
void checkBtn();
 
void setup() {
  if (DEBUG) Serial.begin(9600);
  matrix.begin();

  pinMode(PushL, INPUT); 
  pinMode(PushR, INPUT);
   
  MsTimer2::set(50, checkBtn);
  MsTimer2::start();
}

void loop() {
  if (DEBUG)  {
     for (int i = 0; i < numBall; i++)  {
        for (int j = 0; j < 4; j++)  {
           Serial.print(ball[i][j]);   Serial.print("   ");  
        }
     }
     Serial.println();
  }
  
  matrix.fillScreen(0);
  for (int i = 0; i < numBall; i++)  {
     matrix.fillCircle(ball[i][0], ball[i][1], radius, 
                       matrix.Color333(color[i][0], color[i][1], color[i][2]));
    
     ball[i][0] += ball[i][2];
     ball[i][1] += ball[i][3];
    
     if ( (ball[i][0] <= 0) || (ball[i][0] >= matrix.width() - 1) )   ball[i][2] *= -1;   
     if ( (ball[i][1] <= 0) || (ball[i][1] >= matrix.height() - 1) )  ball[i][3] *= -1;
  }  
  delay( map(analogRead(SlideL), 0, 1023, 500, 0) );
  while(stopPlay)  delay(5);
}

void checkBtn()  {
  if(digitalRead(PushL) == LOW)  stopPlay = true;
  if(digitalRead(PushR) == LOW)  stopPlay = false;
}




