#include "pulsePin.h"
#define DEBUG false
RGBmatrixPanel matrix(A, B, C, CLK, LAT, OE, false);

struct srtRGB  {
   int r;
   int g;
   int b;
};

const int numBall = 3;
int ball[numBall][4]= { {  3,  4,  -1,  -1 }, 
                        { 17, 14,  -1, 1 },
                        { 29,  7,  1,  -1 } };            
srtRGB color[numBall] = { { 7,  0,  0 },
                          { 0,  7,  0 }, 
                          { 0,  0,  7 }  };   
int radius = 4;   

char txtB[numBall] = { 'R', 'G', 'B' };      
srtRGB colorText = { 7, 7, 7 };     

void setup() {
  if (DEBUG) Serial.begin(9600);
  matrix.begin();
  matrix.setTextWrap(false);
  matrix.setTextSize(1);
}

void loop() {
  if (DEBUG)  {
     for (int i = 0; i < numBall; i++)  {
        for (int j = 0; j < 4; j++)  {
           Serial.print(ball[i][j]);   Serial.print("   ");  
        }
     }
     Serial.println();
  }
  
  matrix.fillScreen(0);
  for (int i = 0; i < numBall; i++)  {
     matrix.fillCircle(ball[i][0], ball[i][1], radius, 
                       matrix.Color333(color[i].r, color[i].g, color[i].b));

     matrix.setTextColor( matrix.Color333(colorText.r, colorText.g, colorText.b) ); 
     matrix.setCursor(ball[i][0]-(radius-2), ball[i][1]-(radius-1));  
     matrix.print(txtB[i]);
    
     ball[i][0] += ball[i][2];
     ball[i][1] += ball[i][3];
    
     if ( (ball[i][0] <= 0) || (ball[i][0] >= matrix.width() - 1) )  ball[i][2] *= -1;    
     if ( (ball[i][1] <= 0) || (ball[i][1] >= matrix.height() - 1) )  ball[i][3] *= -1;
  }  
  while(analogRead(SlideL) < 10);
  delay( map(analogRead(SlideL), 10, 1023, 500, 0) );
}




